## dh-python 6.20250414

=== pydist/Makefile ===
#!/usr/bin/make -f

FALLBACK_FLAGS = $(shell dpkg-vendor --is ubuntu && echo '--ubuntu')

all: cpython3_fallback README.PyDist.html

clean:
	rm -rf cache
	#rm -f dist_fallback
	rm -f README.PyDist.html

cpython3_fallback:
	python3 ./generate_fallback_list.py $(FALLBACK_FLAGS)

README.PyDist.html: README.PyDist
	rst2html $< $@

.PHONY: clean

=== tests/Makefile ===
#!/usr/bin/make -f

# enable or disable tests here:
#TESTS := test301 test302 test303 test304 test305 test306 test307 testpb01 testpb02 testpb03 testpb04 testpb05 testpb06 testpb07 testa01 testa02 testa03
TESTS := test301 test302 test303 test304 test305 test306 test307

all: $(TESTS)

test%:
	make -C t$* run
	make -C t$* check

clean-test%:
	make -C t$* clean

clean: $(TESTS:%=clean-%)
	rm -f *\.dsc *\.tar\.gz *\.build *\.changes *\.deb *\.buildinfo
	@find . -prune -name '*.egg-info' -exec rm -rf '{}' ';' || true

.PHONY: clean

=== tests/t302/Makefile ===
#!/usr/bin/make -f
include ../common.mk

check:
	grep -q "py3compile -p python3-foo:$(DEB_HOST_ARCH) /usr/lib/python3-foo"\
		debian/python3-foo/DEBIAN/postinst
	grep -q "pypy3compile -p python3-foo:$(DEB_HOST_ARCH) /usr/lib/python3-foo"\
		debian/python3-foo/DEBIAN/postinst
	grep -q "py3clean -p python3-foo:$(DEB_HOST_ARCH)" debian/python3-foo/DEBIAN/prerm
	[ "`find debian/python3-foo/usr/lib/python3/dist-packages/foo -name 'bar.cpython-*.so'`" != "" ]
	test -e debian/python3-foo/usr/lib/python3-foo/empty-private-dir
	test ! -e debian/python3-foo/usr/lib/python3/dist-packages/empty-public-dir
	# test if moved from include/python3.X/ to include/python3.Xm/ (for Python << 3.8)
	#test -f debian/python3-foo/usr/include/python$(DEBPYTHON3_DEFAULT)m/foo.h

clean:
	./debian/rules clean
	rm -rf lib/Foo.egg-info build

=== tests/t303/Makefile ===
#!/usr/bin/make -f
include ../common.mk

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo.py
	test ! -d debian/python3-foo/usr/lib/python3.*/site-packages
	grep -q 'py3compile -p python3-foo\s*$$' debian/python3-foo/DEBIAN/postinst
	grep -q 'pypy3compile -p python3-foo\s*||\s*true$$' debian/python3-foo/DEBIAN/postinst
	grep -q 'py3clean -p python3-foo\s*$$' debian/python3-foo/DEBIAN/prerm

clean:
	./debian/rules clean

=== tests/t307/Makefile ===
#!/usr/bin/make -f
include ../common.mk

all: run check

run: clean
	dpkg-buildpackage -b -us -uc

check:
	grep -qEe "^Depends: (.* )?python3-cachy($|,| )" \
		debian/python3-foo/DEBIAN/control

clean:
	./debian/rules clean
	rm -rf lib/Foo.egg-info build

=== tests/ta01/Makefile ===
all: run check

run:
	@echo No build needed
ifeq ($(AUTOPKGTEST_TMP),)
	@echo NOTE this test uses the system pybuild-autopkgtest, not the working directory
endif

check: pass fail

pass:
	@echo "=============================================================="
	@echo "= pybuild-autopkgtest passes when tests pass                 ="
	@echo "=============================================================="
	@echo
	pybuild-autopkgtest
	test -f marker-before-pybuild-autopkgtest
	test -f marker-after-pybuild-autopkgtest
	grep '^1$$' marker-PYBUILD_AUTOPKGTEST
	@echo '------------------------------'
	@echo "OK: pybuild-autopkgtest passed"
	@echo '------------------------------'
	@echo

fail:
	@echo "=============================================================="
	@echo "= pybuild-autopkgtest fails when tests fail                  ="
	@echo "=============================================================="
	@echo
	! FAILS=1 pybuild-autopkgtest
	@echo '------------------------------'
	@echo "OK: pybuild-autopkgtest failed"
	@echo '------------------------------'
	@echo

clean:
ifneq ($(AUTOPKGTEST_TMP),)
	rm -r $(AUTOPKGTEST_TMP)/*
endif

=== tests/ta02/Makefile ===
all: run check

run:
	@echo No build needed
ifeq ($(AUTOPKGTEST_TMP),)
	@echo NOTE this test uses the system pybuild-autopkgtest, not the working directory
endif

check:
	DH_VERBOSE=1 pybuild-autopkgtest
	test -e custom-test-executed

clean:
	./debian/rules clean
ifneq ($(AUTOPKGTEST_TMP),)
	rm -r $(AUTOPKGTEST_TMP)/*
endif

=== tests/ta03/Makefile ===
all: run check

run:
	@echo No build needed
ifeq ($(AUTOPKGTEST_TMP),)
	@echo NOTE this test uses the system pybuild-autopkgtest, not the working directory
endif

check:
	DH_VERBOSE=1 pybuild-autopkgtest
	test -e test-ran
	# Assert that we didn't build anything
	test ! -e .pybuild
	test ! -e build
	test ! -e dist

clean:
	./debian/rules clean
ifneq ($(AUTOPKGTEST_TMP),)
	rm -r $(AUTOPKGTEST_TMP)/*
endif

=== tests/tpb01/Makefile ===
#!/usr/bin/make -f
include ../common.mk

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo.py
	grep -q 'Depends:.*python3-cachy' debian/python3-foo/DEBIAN/control
	test -e foo.egg-info/
	./debian/rules clean
	test ! -e foo.egg-info/

clean:
	./debian/rules clean

=== tests/tpb02/Makefile ===
#!/usr/bin/make -f
include ../common.mk

DI=debian/python3-foo/usr/lib/python3/dist-packages/foo-0.1.dist-info

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo/__init__.py
	test -f debian/python3-foo/usr/bin/foo
	test ! -f $(DI)/RECORD
	test ! -f $(DI)/direct_url.json
	grep -q debian debian/python3-foo/usr/lib/python3/dist-packages/foo-0.1.dist-info/INSTALLER
	grep -q 'Depends:.*python3-cachy' debian/python3-foo/DEBIAN/control
	grep -v -q 'Depends:.*python3-importlib-metadata' debian/python3-foo/DEBIAN/control
	grep -L 'Depends:.*tox' debian/python3-foo/DEBIAN/control | grep -q control
	find .pybuild -name test-executed | grep -q test-executed
	test -f debian/python3-foo/usr/share/man/man1/foo.1.gz

clean:
	./debian/rules clean

=== tests/tpb03/Makefile ===
#!/usr/bin/make -f
include ../common.mk

check:
	# FIXME: This used to be a 2.7 + 3.x test. It may not be useful any more, without 2.x
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo.py
	grep -q 'Depends:.*python3-pkg-resources' debian/python3-foo/DEBIAN/control
	./debian/rules clean
	test -f foo.egg-info/SOURCES.txt
	grep -q extra-file foo.egg-info/SOURCES.txt
	test ! -f foo.egg-info/PKG-INFO
	test ! -f foo.egg-info/dependency_links.txt
	test ! -f foo.egg-info/requires.txt
	test ! -f foo.egg-info/top_level.txt

clean:
	./debian/rules clean

=== tests/tpb05/Makefile ===
#!/usr/bin/make -f
include ../common.mk

DI=debian/python3-foo/usr/lib/python3/dist-packages/foo-0.1.dist-info

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo/__init__.py
	test ! -f $(DI)/RECORD
	test ! -f $(DI)/direct_url.json
	grep -q 'Depends:.*python3-cachy' debian/python3-foo/DEBIAN/control
	grep -v -q 'Depends:.*python3-importlib-metadata' debian/python3-foo/DEBIAN/control
	grep -L 'Depends:.*tox' debian/python3-foo/DEBIAN/control | grep -q control
	find .pybuild -name test-executed | grep -q test-executed
	grep -q usr/bin/python3$$ debian/python3-foo/usr/bin/foo
	find debian/python3-foo/usr/lib/python3/dist-packages/ -name LICENSE | { ! grep -q LICENSE; }

clean:
	./debian/rules clean

=== debian/changelog ===
dh-python (6.20250414) unstable; urgency=medium

  [ Colin Watson ]
  * Document "architecture" field in
    debian/tests/autopkgtest-pkg-pybuild.conf.

  [ Stefano Rivera ]
  * Parse an unversioned python shebang as being Python 3. This eases handling
    for setuptools >= 76 which, will emit "/usr/bin/python" shebangs, even
    when the build is run by "/usr/bin/python3". (Closes: #1103150)
  * Bump Standards-Version to 4.7.2, no changes needed.
  * Update pydist data.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 14 Apr 2025 16:39:29 -0400

=== tests/t306/debian/changelog ===
foo (0.1) unstable; urgency=low

  * Initial release

 -- Maximilian Engelhardt <maxi@daemonizer.de>  Sun, 04 Apr 2021 13:09:48 +0200

=== debian/control ===
Source: dh-python
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Uploaders:
 Stefano Rivera <stefanor@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libdpkg-perl,
 libpython3-stdlib,
 python3-all <!nocheck>,
 python3-all-dbg <!nocheck>,
 python3-all-dev <!nocheck>,
 python3-docutils <!nodoc>,
 python3-minimal,
 python3-nose2 <!nocheck>,
 python3-setuptools,
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/python-team/tools/dh-python.git
Vcs-Browser: https://salsa.debian.org/python-team/tools/dh-python
Rules-Requires-Root: no

Package: dh-python
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${python3:Depends},
Provides:
 dh-sequence-python3,
Suggests:
 dpkg-dev,
 flit,
 libdpkg-perl,
 python3-build,
 python3-installer,
 python3-wheel,
Breaks:
# due to /usr/bin/dh_python3 and debhelper files
 python3 (<< 3.3.2-4~),
Description: Debian helper tools for packaging Python libraries and applications
 This package contains:
  * pybuild - invokes various build systems for requested Python versions in
    order to build modules and extensions
  * dh_python3 - calculates Python 3.X dependencies for Debian packages,
    adds maintainer scripts to byte compile files, etc.

Package: pybuild-plugin-pyproject
Architecture: all
Multi-Arch: foreign
Depends:
 dh-python (= ${source:Version}),
 python3-build (>> 0.7~),
 python3 (>> 3.11~) | python3-tomli,
 python3-installer,
 ${misc:Depends},
Description: Debian helper tools for packaging Python libraries using PEP517
 This metapackage depends on the components necessary for building packages
 with the generic PEP517 build plugin.

Package: pybuild-plugin-autopkgtest
Architecture: all
Multi-Arch: foreign
Depends:
 debhelper,
 dh-python (= ${source:Version}),
 make,
 ${misc:Depends},
Description: pybuild autopkgtest test runner (metapackage)
 This package depends on the packages required to run pybuild-autopkgtest, a
 pybuild-based autopkgtest test runner. pybuild-autopkgtest will run the same
 test suite that regular pybuild runs during build time, but against the
 installed packages and without doing a build first.

=== tests/t301/debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_install:
	python3 setup.py install --root=debian/python3-foo/
	# Leave some coverage droppings
	mkdir -p debian/python3-foo/usr/lib/python3/dist-packages
	/usr/bin/printf '\xe2\x28\xa1' > debian/python3-foo/usr/lib/python3/dist-packages/.coverage
	mkdir -p debian/python3-foo/usr/lib/$(shell py3versions -d)/dist-packages
	/usr/bin/printf '\xe2\x82\x28' > debian/python3-foo/usr/lib/$(shell py3versions -d)/dist-packages/.coverage

override_dh_install:
	dh_install
	find debian/ -name jquery.js -exec \
	ln -fs /usr/share/javascript/jquery/jquery.js '{}' \;
	DH_VERBOSE=1 ../../dh_python3\
		--depends 'SQLAlchemy >= 0.6.1'\
		--recommends Mako\
		--suggests 'Foo >= 0.1'\
		--suggests 'bar >= 1.0'

clean:
	rm -rf build Foo.egg-info
	dh clean

override_dh_auto_build:
override_dh_auto_test:

override_dh_auto_clean:
	#python3 setup.py clean

=== tests/t302/debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_install:
	dh_install
	# install also as private extension
	dh_install debian/python3-foo/usr/local/lib/python3*/dist-packages/foo/bar*.so \
		/usr/lib/python3-foo/
	mkdir -p debian/python3-foo/usr/lib/python3/dist-packages/empty-public-dir
	mkdir -p debian/python3-foo/usr/lib/python3-foo/empty-private-dir
	DH_VERBOSE=1 ../../dh_python3

comma:=,
empty:=
space:= $(empty) $(empty)
PYTHONS=$(subst $(comma),$(space),$(DEBPYTHON3_SUPPORTED))
override_dh_auto_build:
	for ver in $(PYTHONS); do\
	  python$$ver setup.py build; done

override_dh_auto_test:

override_dh_auto_install:
	for ver in $(PYTHONS); do\
	  python$$ver setup.py install --root=debian/python3-foo;\
	done
	mkdir -p debian/python3-foo/usr/include/python$(DEBPYTHON3_DEFAULT)/
	touch debian/python3-foo/usr/include/python$(DEBPYTHON3_DEFAULT)/foo.h

override_dh_auto_clean:
	rm -rf Foo.egg-info

=== tests/t305/debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=none

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/foo5e/usr/share/foo/
	echo "#! /usr/bin/env $(shell py3versions -d)\n\"/usr/bin/env DEFAULT_PYTHON shebang\"" > debian/foo5e/usr/share/foo/foo5e
	chmod +x debian/foo5e/usr/share/foo/foo5e
	mkdir -p debian/foo5f/usr/share/foo/
	echo "#! /usr/bin/$(shell py3versions -d)\n\"/usr/bin/DEFAULT_PYTHON shebang\"" > debian/foo5f/usr/share/foo/foo5f
	chmod +x debian/foo5f/usr/share/foo/foo5f

override_dh_install:
	dh_install
	DH_VERBOSE=1 ../../dh_python3 -p foo5a /usr/share/foo
	DH_VERBOSE=1 ../../dh_python3 --remaining-packages /usr/share/foo
	cp debian/foo5a.debhelper.log debian/foo5a.debhelper.log.end_dh_install

clean:
	rm -f debian/foo5a.debhelper.log.end_dh_install
	dh_clean

=== tests/t307/debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=none

override_dh_install:
	dh_install
	PYTHONPATH=../.. DH_VERBOSE=1 ../../dh_python3

override_dh_auto_build:

override_dh_auto_install:
	mkdir -p debian/python3-foo/usr/lib/python3/dist-packages
	cp -a Foo.egg-info lib/* debian/python3-foo/usr/lib/python3/dist-packages

=== tests/tpb01/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo

%:
	dh $@

override_dh_auto_build:
	../../pybuild --build --verbose

override_dh_auto_install:
	../../pybuild --install --verbose

override_dh_auto_test:
	../../pybuild --test --verbose

override_dh_auto_clean:
	../../pybuild --clean --verbose
	rm -rf .pybuild

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

=== tests/tpb04/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo
export PYBUILD_EXT_DESTDIR_python3=debian/python3-foo-ext

%:
	dh $@

override_dh_auto_build:
	../../pybuild --build --verbose

override_dh_auto_install:
	../../pybuild --install --verbose

override_dh_auto_test:
	../../pybuild --test --test-tox --test-args=-v --verbose

override_dh_auto_clean:
	../../pybuild --clean --verbose
	rm -rf .pybuild .tox foo.egg-info test-executed

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

=== tests/tpb05/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo

%:
	dh $@

override_dh_auto_build:
	../../pybuild --build --verbose
	../../pybuild --build --verbose

override_dh_auto_install:
	../../pybuild --install --verbose
	../../pybuild --install --verbose

override_dh_auto_test:
	../../pybuild --test --test-pytest --verbose

override_dh_auto_clean:
	../../pybuild --clean --verbose
	rm -rf .pybuild

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

=== tests/tpb07/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo

%:
	dh $@

override_dh_auto_build:
	../../pybuild -d foo --build --verbose --name=foo
	../../pybuild -d bar --build --verbose --name=bar

override_dh_auto_install:
	../../pybuild -d foo --install --verbose --name=foo
	../../pybuild -d bar --install --verbose --name=bar

override_dh_auto_test:
	../../pybuild -d foo --test --verbose --name=foo --test-tox --test-args=-v
	../../pybuild -d bar --test --verbose --name=bar --test-pytest -v

override_dh_auto_clean:
	../../pybuild -d foo --clean --verbose --name=foo
	../../pybuild -d bar --clean --verbose --name=bar
	rm -rf .pybuild foo/.tox foo/tests-executed-foo

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

=== debian/tests/control ===
Tests: dh-python
Depends:
 build-essential,
 debhelper,
 dh-python,
 fakeroot,
 libjs-jquery,
 python3-all-dbg,
 python3-all-dev,
 python3-setuptools,
Restrictions: allow-stderr

Tests: nosetests
Depends:
 dh-python,
 flit,
 python3-all,
 python3-all-dbg,
 python3-nose2,
Restrictions: allow-stderr

Tests: pybuild
Depends:
 build-essential,
 debhelper,
 dh-python,
 fakeroot,
 flit,
 pybuild-plugin-pyproject,
 python3-all-dev,
 python3-cachy,
 python3-poetry-core,
 python3-pytest,
 python3-setuptools,
 python3-setuptools-scm,
 tox (>= 4),
Restrictions: allow-stderr

Tests: pybuild-autopkgtest
Depends:
 autopkgtest,
 debhelper,
 dh-python,
 make,
 pybuild-plugin-pyproject,
 python3-all,
 python3-pytest,
 tox
Restrictions: allow-stderr

=== tests/t301/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper (>= 7.0.50~), python3-all
Standards-Version: 3.9.0
Rules-Requires-Root: no
X-Python3-Version: >= 3.1, << 3.9

Architecture: all
Package: python3-foo
Depends: ${python3:Depends}, ${misc:Depends}
Recommends: ${python3:Recommends}
Suggests: ${python3:Suggests}
Enhances: ${python3:Enhances}
Breaks: ${python3:Breaks}
Provides: ${python3:Provides}
Description: foo to rule them all
 example package #1

=== tests/t305/debian/control ===
Source: foo
Section: misc
Priority: optional
Maintainer: Maximilian Engelhardt <maxi@daemonizer.de>
Build-Depends: debhelper (>= 12.9)
Build-Depends-Indep: python3
Rules-Requires-Root: no
Standards-Version: 4.5.1

Package: foo5a
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: example 5a - private shebangs
 example package #5 - shebang related tests in private dirs

Package: foo5b
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: example 5b - private shebangs
 example package #5 - shebang related tests in private dirs

Package: foo5c
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: example 5c - private shebangs
 example package #5 - shebang related tests in private dirs

Package: foo5d
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: example 5d - private shebangs
 example package #5 - shebang related tests in private dirs

Package: foo5e
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: example 5e - private shebangs
 example package #5 - shebang related tests in private dirs

Package: foo5f
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: example 5f - private shebangs
 example package #5 - shebang related tests in private dirs

=== tests/t307/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Maximilian Engelhardt <maxi@daemonizer.de>
Build-Depends: debhelper (>= 12.9), python3-all-dev:any
Rules-Requires-Root: no
Standards-Version: 4.5.1

Package: python3-foo
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: package with python3-all-dev dependency using :any
 example package #6 - private Python extensions and python3-all-dev:any
 dependency

=== tests/ta02/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper-compat (= 12)
 , pybuild-plugin-pyproject
 , python3-all
 , python3-pytest
 , python3-setuptools
Rules-Requires-Root: no
Standards-Version: 3.9.4

Package: python3-foo
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with public CPython modules
 example package #8

=== tests/tpb02/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper-compat (= 12)
 , flit
 , python3-all
 , pybuild-plugin-pyproject
# , dh-python
Rules-Requires-Root: no
Standards-Version: 3.9.4

Package: python3-foo
Architecture: all
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with public CPython modules
 example package #1

=== tests/tpb03/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper-compat (= 12)
 , python3-all
 , python3-setuptools
 , python3-setuptools-scm
# , dh-python
Rules-Requires-Root: no
Standards-Version: 3.9.4

Package: python3-foo
Architecture: all
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with public CPython modules
 example package #1

## dh-python 6.20251029

=== tests/tpb04/Makefile ===
#!/usr/bin/make -f
include ../common.mk

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo.py
	test -f debian/python3-foo-ext/usr/lib/python3/dist-packages/_foo.abi3-$(DEB_HOST_MULTIARCH).so
	test -e test-executed

clean:
	./debian/rules clean

=== debian/changelog ===
dh-python (6.20251029) unstable; urgency=medium

  [ Colin Watson ]
  * dh_python3: Suppress generated dependencies that would be satisfied by
    python3 >= 3.11.

  [ Matthias Klose ]
  * autoscripts/prerm-py3clean: Check for a working /usr/bin/python3,
    the same interpreter used for py3clean.  Addresses: #1109501.

  [ Stefano Rivera ]
  * Update the list of Python versions we test things for.
  * Rename stable ABI extensions to include a multiarch tuple, allowing
    co-installation.

  [ Simon Chopin ]
  * pybuild: add an optional dest arg to testfiles syntax (Closes: #947800)

  [ Niels Thykier ]
  * dh_python3: Add introspection hints for known configuration files

 -- Stefano Rivera <stefanor@debian.org>  Wed, 29 Oct 2025 15:53:03 +0200

## dh-python 6.20251201

=== debian/changelog ===
dh-python (6.20251201) unstable; urgency=medium

  [ Stefano Rivera ]
  * Remove setuptools -> python3-pkg-resources mapping from pydist,
    pkg_resources is deprecated upstream.
  * Update pydist data.

  [ Colin Watson ]
  * Normalize names in pydist lookups.
  * pyproject plugin: Support headers (closes: #1115299).

 -- Stefano Rivera <stefanor@debian.org>  Mon, 01 Dec 2025 14:56:52 -0400

## dh-python 6.20251204

=== tests/tpb03/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 check:
 	# FIXME: This used to be a 2.7 + 3.x test. It may not be useful any more, without 2.x
 	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo.py
-	grep -q 'Depends:.*python3-pkg-resources' debian/python3-foo/DEBIAN/control
+	grep -q 'Depends:.*python3-setuptools' debian/python3-foo/DEBIAN/control
 	./debian/rules clean
 	test -f foo.egg-info/SOURCES.txt
 	grep -q extra-file foo.egg-info/SOURCES.txt

=== debian/changelog ===
dh-python (6.20251204) unstable; urgency=medium

  [ Colin Watson ]
  * pyproject plugin: Use correct version-specific include directory when
    installing headers.

  [ Stefano Rivera ]
  * Handle multiarch tuples when merging stable ABI extensions.
  * Don't let a package containing one stable ABI module generate wide-open
    python dependencies. (Closes: #1121868)

 -- Stefano Rivera <stefanor@debian.org>  Thu, 04 Dec 2025 10:46:17 -0400

## dh-python 6.20251204.1

=== debian/changelog ===
dh-python (6.20251204.1) unstable; urgency=medium

  * Fix a regression in 6.20251204: Generate dependencies for packages
    containing stable ABI extensions (Closes: #1121868)
  * Properly handle Stable ABI extensions.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 04 Dec 2025 15:48:10 -0400

## dh-python 6.20251221

=== debian/changelog ===
dh-python (6.20251221) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Enable parallel building of setuptools extensions, both with the distutils
    backend and the pyproject backend. Parallel building is only enabled
    if "parallel=N" is present in DEB_BUILD_OPTIONS in accordance with
    Debian policy § 4.9.1. (Closes: #1093869)

  [ Stefano Rivera ]
  * Remove tox 3 support.
  * Add Type annotations and blacken the codebase.
  * Some related code-base refactoring and cleanup.
  * Prepend python3-supported-min (>= 3.13.1) | before packages requiring a
    minimum Python version. (Closes: #1119036)
  * Keep platform requirements if they apply to one of several supported
    environments. (Closes: #1100737)
  * Drop GNU/kFreeBSD from supported platforms.
  * Ignore blank lines in pybuild.testfiles. (Closes: #1123536)
  * Update cpython3_fallback.
  * Add --test-unittest to explicitly select the unittest runner.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 21 Dec 2025 17:07:09 -0400

## dh-python 7.20251223

=== Makefile ===
#!/usr/bin/make -f
INSTALL ?= install
PREFIX ?= /usr/local
MANPAGES ?= pybuild.1 pybuild-autopkgtest.1 dh_python3.1
DVERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+),\1,p' || echo 'DEVEL')
VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p' || echo 'DEVEL')

clean:
	make -C tests clean
	make -C pydist clean
	find . -name '*.py[co]' -delete
	find . -name __pycache__ -type d | xargs rm -rf
	rm -f .coverage $(MANPAGES)
	rm -rf .pybuild

dist:
	git archive --format=tar --prefix=dh-python-$(VERSION)/ HEAD \
	| xz -9 -c >../dh-python_$(VERSION).orig.tar.xz

install:
	$(INSTALL) -m 755 -d $(DESTDIR)$(PREFIX)/bin \
		$(DESTDIR)$(PREFIX)/share/debhelper/autoscripts/ \
		$(DESTDIR)$(PREFIX)/share/perl5/Debian/Debhelper/Sequence/ \
		$(DESTDIR)$(PREFIX)/share/perl5/Debian/Debhelper/Buildsystem/ \
		$(DESTDIR)$(PREFIX)/share/dh-python/dhpython/build \
		$(DESTDIR)$(PREFIX)/share/dh-python/dist
	$(INSTALL) -m 644 pydist/*_fallback $(DESTDIR)$(PREFIX)/share/dh-python/dist/
	$(INSTALL) -m 644 dhpython/*.py $(DESTDIR)$(PREFIX)/share/dh-python/dhpython/
	$(INSTALL) -m 644 dhpython/build/*.py $(DESTDIR)$(PREFIX)/share/dh-python/dhpython/build/
	$(INSTALL) -m 755 pybuild $(DESTDIR)$(PREFIX)/share/dh-python/
	$(INSTALL) -m 755 pybuild-autopkgtest $(DESTDIR)$(PREFIX)/share/dh-python/
	$(INSTALL) -m 755 dh_python3 $(DESTDIR)$(PREFIX)/share/dh-python/
	sed -i -e 's/DEVELV/$(DVERSION)/' $(DESTDIR)$(PREFIX)/share/dh-python/pybuild
	sed -i -e 's/DEVELV/$(DVERSION)/' $(DESTDIR)$(PREFIX)/share/dh-python/dh_python3
	
	$(INSTALL) -m 644 dh/pybuild.pm $(DESTDIR)$(PREFIX)/share/perl5/Debian/Debhelper/Buildsystem/
	$(INSTALL) -m 644 dh/python3.pm $(DESTDIR)$(PREFIX)/share/perl5/Debian/Debhelper/Sequence/
	$(INSTALL) -m 644 autoscripts/* $(DESTDIR)$(PREFIX)/share/debhelper/autoscripts/

%.1: %.rst
	rst2man $< > $@

%.htm: %.rst
	rst2html $< > $@

manpages: $(MANPAGES)

dist_fallback:
	make -C pydist $@

# TESTS
nose:
	#nosetests3 --verbose --with-doctest --with-coverage
	nose2-3 --verbose --plugin nose2.plugins.doctests --with-doctest

mypy:
	mypy --strict dh_python3 dhpython/ tests/*.py
	mypy --strict pybuild

black:
	black $(BLACK_ARGS) pybuild dh_python3 dhpython/ pydist/*.py tests/*.py

tests: nose
	make -C tests

test%:
	make -C tests $@

.PHONY: clean tests test% check_versions

=== debian/changelog ===
dh-python (7.20251223) unstable; urgency=medium

  * Bump major-version, post-trixie (a little late).
  * Fix pybuild --print (broken in the last upload).

 -- Stefano Rivera <stefanor@debian.org>  Tue, 23 Dec 2025 08:04:11 -0400

## dh-python 7.20251225

=== tests/tpb06/Makefile ===
#!/usr/bin/make -f
include ../common.mk

DI=debian/python3-foo/usr/lib/python3/dist-packages/foo-0.1.dist-info

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo/__init__.py
	test ! -f $(DI)/RECORD
	test ! -f $(DI)/direct_url.json
	grep -q 'Depends:.*python3-cachy' debian/python3-foo/DEBIAN/control
	grep -v -q 'Depends:.*python3-importlib-metadata' debian/python3-foo/DEBIAN/control
	grep -L 'Depends:.*tox' debian/python3-foo/DEBIAN/control | grep -q control
	find .pybuild -name test-executed | grep -q test-executed
	grep -q usr/bin/python3$$ debian/python3-foo/usr/bin/foo
	find debian/python3-foo/usr/lib/python3/dist-packages/ -name LICENSE | { ! grep -q LICENSE; }
	set -e; for py in $(shell py3versions -s); do \
		test -f debian/python3-foo/usr/include/$$py/foo/ext.h; \
	done
	test -f debian/python3-foo/usr/share/man/man1/foo.1.gz

clean:
	./debian/rules clean

=== debian/changelog ===
dh-python (7.20251225) unstable; urgency=medium

  [ Stefano Rivera ]
  * Configure a reproducible build-dir for meson pyproject builds.
    (Closes: #1113976)
  * pybuild: Allow --name's effect on --dest-dir to be overridden
  * Compare absolute paths in pybuild when deciding to skip passing destdir
  * Use Python 3.11 compatible alias syntax (pypy3 is still 3.11)
  * pyupgrade --py311-plus

  [ Alexandre Detiste ]
  * drop conditional dependency on python3-tomli backport
  * trim dead code for Python < 3.11

 -- Stefano Rivera <stefanor@debian.org>  Thu, 25 Dec 2025 11:48:54 -0400

## dh-python 7.20251227

=== debian/changelog ===
dh-python (7.20251227) unstable; urgency=medium

  * Refactor internals to use dataclasses.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 27 Dec 2025 20:40:29 -0400

## dh-python 7.20251231

=== debian/changelog ===
dh-python (7.20251231) unstable; urgency=medium

  * Fix a regression in pybuild in 7.20251227. (Closes: #1124229)

 -- Stefano Rivera <stefanor@debian.org>  Wed, 31 Dec 2025 12:15:31 -0400

=== tests/tpb01/debian/rules ===
--- 
+++ 
@@ -4,6 +4,11 @@
 
 %:
 	dh $@
+
+override_dh_auto_configure:
+	echo "Package name:"
+	../../pybuild --print package
+	../../pybuild --configure --verbose
 
 override_dh_auto_build:
 	../../pybuild --build --verbose

## dh-python 7.20260125

=== Makefile ===
--- 
+++ 
@@ -48,17 +48,20 @@
 dist_fallback:
 	make -C pydist $@
 
-# TESTS
-nose:
-	#nosetests3 --verbose --with-doctest --with-coverage
-	nose2-3 --verbose --plugin nose2.plugins.doctests --with-doctest
-
 mypy:
 	mypy --strict dh_python3 dhpython/ tests/*.py
 	mypy --strict pybuild
 
 black:
 	black $(BLACK_ARGS) pybuild dh_python3 dhpython/ pydist/*.py tests/*.py
+
+pyupgrade:
+	pyupgrade --py311-plus dh_python3 pybuild pydist/*.py tests/*.py $(shell find dhpython -name *.py)
+
+# TESTS
+nose:
+	#nosetests3 --verbose --with-doctest --with-coverage
+	nose2-3 --verbose --plugin nose2.plugins.doctests --with-doctest
 
 tests: nose
 	make -C tests

=== tests/t303/Makefile ===
#!/usr/bin/make -f
include ../common.mk

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo.py
	test ! -d debian/python3-foo/usr/lib/python3.*/site-packages
	grep -q 'py3compile -p python3-foo\s*||\s*true$$' debian/python3-foo/DEBIAN/postinst
	grep -q 'pypy3compile -p python3-foo\s*||\s*true$$' debian/python3-foo/DEBIAN/postinst
	grep -q 'py3clean -p python3-foo\s*$$' debian/python3-foo/DEBIAN/prerm

clean:
	./debian/rules clean

=== debian/changelog ===
dh-python (7.20260125) unstable; urgency=medium

  * Catch TOMLDecodeError in plugin_pyproject
  * Drop python2.* autoscripts
  * autoscripts: Ignore py3compile failure (Closes: #1125979)

 -- Stefano Rivera <stefanor@debian.org>  Sun, 25 Jan 2026 14:05:36 -0400

=== debian/control ===
--- 
+++ 
@@ -51,7 +51,6 @@
 Depends:
  dh-python (= ${source:Version}),
  python3-build (>> 0.7~),
- python3 (>> 3.11~) | python3-tomli,
  python3-installer,
  ${misc:Depends},
 Description: Debian helper tools for packaging Python libraries using PEP517
